#define maxN 1000
#define m 1000003

#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

char letters[maxN][maxN];
char word[2 * maxN - 1];
int N;

int main()
{
    freopen("line.dat", "r", stdin);
    freopen("line.sol", "w", stdout);

    scanf("%d\n", &N);
    for (int i = 0; i < N; i++)
    {
        for (int j = 0; j < N; j++)
            scanf("%c", &letters[i][j]);
        scanf("\n");
    }
    for (int i = 0; i < 2 * N - 1; i++)
        scanf("%c", &word[i]);

    vector<int> v;
    for (int i = 0; i < N - 1; i++)
        v.push_back(0);
    for (int i = 0; i < N - 1; i++)
        v.push_back(1);

    int answer = 0;
    do {
        int line = 0;
        int row = 0;
        if (letters[line][row] != word[0])
            continue;
        bool willDo = true;
        for (int i = 0; i < v.size(); i++)
        {
            if (v[i])
                line++;
            else
                row++;
            if (letters[line][row] != word[i + 1])
            {
                willDo = false;
                break;
            }
        }
        if (willDo)
        {
            answer++;
            if (answer >= m)
                answer -= m;
        }
    } while (next_permutation(v.begin(), v.end()));

    printf("%d\n", answer);
    return 0;
}
