#define maxSize 1000000

#include <stdio.h>

int T, N, M;
int cols[maxSize], rows[maxSize]; //      
int colsIndex[maxSize + 1], rowsIndex[maxSize + 1]; // ʳ ,    ,   cols  rows

//          
bool check()
{
    //       ,      :
    for (int i = 0; i <= M; i++)
        colsIndex[i] = 0;
    long long colSum = 0;
    for (int i = 0; i < N; i++)
    {
        colSum += cols[i];
        colsIndex[cols[i]]++;
    }

    //       ,      :
    for (int i = 0; i <= N; i++)
        rowsIndex[i] = 0;
    long long rowSum = 0;
    for (int i = 0; i < M; i++)
    {
        rowSum += rows[i];
        rowsIndex[rows[i]]++;
    }

    //        ,  ( )    
    if (colSum != rowSum)
        return false;

    int colPointer = M; //       
                        // (      M     
    long long currentColSum = 0; //             
    int rowPointer = 0; //          (    )
    int currentRowCount = M; //            ,    (  )
    long long currentRowSum = 0; //       
    while (colPointer >= 0) //        
        if (colsIndex[colPointer] > 0) //        
        {
            colsIndex[colPointer]--; //      ,     
            currentColSum += colPointer; //      

            //    :
            currentRowCount -= rowsIndex[rowPointer]; //       
            rowPointer++; //   
            currentRowSum += currentRowCount; //   ,    ,  ,     ,   

            if (currentColSum > currentRowSum) //     ,  
                return false;
        } else //     -
            colPointer--;

    return true; //      ,   
}

int main()
{
    freopen("puzzle.dat", "r", stdin);
    freopen("puzzle.sol", "w", stdout);

    scanf("%d", &T);
    for (int test = 0; test < T; test++)
    {
        scanf("%d %d", &N, &M);
        for (int i = 0; i < N; i++)
            scanf("%d", &cols[i]);
        for (int i = 0; i < M; i++)
            scanf("%d", &rows[i]);
        printf("%d\n", check() ? 1 : 0);
    }

    return 0;
}
