#define maxSize 1000000

#include <stdio.h>

int T, N, M, cols[maxSize], rows[maxSize];

bool check()
{
    long long colSum = 0, rowSum = 0;
    int maxCol = 0, maxRow = 0, zerosCol = 0, zerosRow = 0;
    for (int i = 0; i < N; i++)
    {
        colSum += cols[i];
        if (cols[i] > maxCol)
            maxCol = cols[i];
        if (cols[i] == 0)
            zerosCol++;
    }
    for (int i = 0; i < M; i++)
    {
        rowSum += rows[i];
        if (rows[i] > maxRow)
            maxRow = rows[i];
        if (rows[i] == 0)
            zerosRow++;
    }

    if (colSum != rowSum)
        return false;

    if (maxCol + zerosRow > M)
        return false;

    if (maxRow + zerosCol > N)
        return false;

    return true;
}

int main()
{
    freopen("puzzle.dat", "r", stdin);
    freopen("puzzle.sol", "w", stdout);

    scanf("%d", &T);
    for (int test = 0; test < T; test++)
    {
        scanf("%d %d", &N, &M);
        for (int i = 0; i < N; i++)
            scanf("%d", &cols[i]);
        for (int i = 0; i < M; i++)
            scanf("%d", &rows[i]);
        printf("%d\n", check() ? 1 : 0);
    }

    return 0;
}
