#define maxN 1000
#define m 1000003

#include <stdio.h>

char letters[maxN][maxN]; //   (   ,  )
char word[2 * maxN - 1];  //  
int N, cnt[maxN][maxN];   //  cnt[line][row]           

//        ,   ,
//       cnt[line][row],    line
//    row     ,  0,  .
inline int getCount(int line, int row)
{
    if (line < 0 || row < 0)
        return 0;
    else
        return cnt[line][row];
}

int main()
{
    freopen("line.dat", "r", stdin);
    freopen("line.sol", "w", stdout);

    //  :
    scanf("%d\n", &N);
    for (int i = 0; i < N; i++)
    {
        for (int j = 0; j < N; j++)
            scanf("%c", &letters[i][j]);
        scanf("\n");
    }
    for (int i = 0; i < 2 * N - 1; i++)
        scanf("%c", &word[i]);

    //     ,  ,     .
    //        ,     
    //   getCount.
    if (letters[0][0] != word[0])
    {
        printf("0\n");
        return 0;
    }

    cnt[0][0] = 1; //    
    for (int i = 1; i < 2 * N - 1; i++) //    
    {
        int initialLine, initialRow, length; //    ,   
                                             //    ,  
                                             //      
        if (i < N)
        {
            initialLine = 0;
            initialRow = i;
            length = i + 1;
        } else
        {
            initialLine = i - N + 1;
            initialRow = N - 1;
            length = 2 * N - i - 1;
        }
        for (int j = 0; j < length; j++) //     
        {
            int line = initialLine + j; //  ,     
            int row = initialRow - j;   //  ,     
            cnt[line][row] = letters[line][row] == word[i]
                             ? (getCount(line - 1, row) + getCount(line, row - 1)) % m
                             : 0; //         ,    , , 
        }
    }

    //    ,     :
    printf("%d\n", cnt[N - 1][N - 1]);
    return 0;
}
